#include <iostream>
using namespace std;
int main(){
    int t, n, i, j, x;
    ios::sync_with_stdio( false );
    cin.tie( 0 );
    cout.tie( 0 );
    cin >> t;
    for( j = 0; j < t; j++ ){
        cin >> n;
        for( i = 0; i < n; i++ ){
            cin >> x;
        }
        for( i = n - 1; i >= 0; i-- ){
            cout << i << ' ';
        }
        cout << '\n';
    }
    return 0;
}
